<template>
  <AdminCollection>
    <h1 slot="title">Pages</h1>
    <template #actions>
      <el-button type="primary" @click="$router.push(`/admin/pages/create`)">
        Create
      </el-button>
    </template>

    <el-table
      :data="pages"
      style="width: 100%"
      v-loading="deleteLoading"
      v-if="pages"
    >
      <el-table-column label="Name" sortable prop="name" />
      <el-table-column label="Slug" sortable prop="slug" />
      <el-table-column label="Active" sortable prop="active">
        <template slot-scope="scope">
          <el-tag :type="scope.row.active ? 'success' : 'info'" size="mini">
            {{ scope.row.active ? 'Yes' : 'No' }}
          </el-tag>
        </template>
      </el-table-column>
      <el-table-column label="Locales" sortable prop="locales">
        <template slot-scope="scope">
          <el-tag
            v-for="(locale, index) in scope.row.pages_contents.flatMap(
              c => c.locale
            )"
            :key="index"
            type="info"
            style="margin-right: 8px"
          >
            {{ locale.replace('_', '').toUpperCase() }}
          </el-tag>
        </template>
      </el-table-column>

      <el-table-column align="right">
        <template slot-scope="scope">
          <el-button
            type="primary"
            plain=""
            size="small"
            @click="$router.push(`/admin/pages/${scope.row.id}`)"
          >
            Edit
          </el-button>
          <el-button
            :disabled="scope.row.slug === '/'"
            type="danger"
            plain=""
            size="small"
            @click="deletePage(scope.row)"
          >
            Delete
          </el-button>
        </template>
      </el-table-column>
    </el-table>
  </AdminCollection>
</template>

<script lang="ts">
import { defineComponent, inject } from '@nuxtjs/composition-api'
import { useAdminDeletePageMutation } from '@/sdk/hooks'
import AdminCollection from '@/components/admin/AdminCollection.vue'
import { AdminPagesProvider } from '~/types/admin'
import { PageWithLocalesFragment } from '~/sdk/types'

export default defineComponent({
  layout: 'admin',
  name: 'PersonalAdminPagesPage',
  components: { AdminCollection },
  setup(_, { root }) {
    const pages = inject(AdminPagesProvider)

    const { mutate, loading: deleteLoading } = useAdminDeletePageMutation({
      errorPolicy: 'all',
      context: {
        headers: {
          'x-hasura-role': 'administrator'
        }
      }
    })

    function deletePage(page: PageWithLocalesFragment) {
      root.$confirm(`Delete page ${page.name}?`, {
        type: 'warning',
        confirmButtonText: 'OK',
        cancelButtonText: 'Cancel',
        center: true,
        callback(action) {
          if (action === 'confirm') mutate({ id: page.id })
        }
      })
    }

    return { pages, deletePage, deleteLoading }
  }
})
</script>
